// ENTITYMD2 Class    (c) by Heinrich Tillack 2002
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license
// v 0 (21.10.02): initial release


#include "entitymd2.h"
#include <GL/gl.h>
#include <stdio.h>
#include <kos.h>

#include "sphere.hpp"

extern "C" {
	#include "all.h"
}


ENTITY_MD2::ENTITY_MD2(){

    model=NULL;
    tex_id=-1;
    BoundingSphere.Clear();
    ClipState=FULL_INSIDE;
}

ENTITY_MD2::~ENTITY_MD2()
{


    if(model!=NULL){
        free_md2(model);

    }

    delete_tex(tex_id) ;
    tex_id=-1;

}


GLvoid  ENTITY_MD2::SetBoundingSphere(){



    BoundingSphere.SetRadius(getBoundingSphere_md2 (GetModel(),  &BoundingSphere.center.x,    &BoundingSphere.center.y,&BoundingSphere.center.z));




}



GLvoid ENTITY_MD2::Load(char *model_name, char *skin_name,float scale=1){

    int type;

    DBG("ent.c:load_md2..\n");

    model=load_md2(model_name,scale);

    tex_id=auto_load_texture(skin_name);


    SetBoundingSphere();



//     printf("ENTITY_MD2 has BoundingSphere Radius of %f\n",
//            BoundingSphere.GetRadius()
//           );

//     printf("ENTITY_MD2 has Sphere-Center %f,%f,%f \n",BoundingSphere.center.x,
//            BoundingSphere.center.y,
//            BoundingSphere.center.z
//           );

}

GLvoid ENTITY_MD2::Draw()
{


    Context		&context = Context::Get();

	#define Pos Position

    ClipState=context.GetFrustrum()->SphereInFrustum(Pos.x,Pos.y,Pos.z, BoundingSphere.GetRadius());

    if(ClipState==FULL_OUTSIDE) {
        //printf("MD2 Object is outside\n");
        return;
    }
    else if(ClipState==FULL_INSIDE) glDisable(GL_KOS_NEARZ_CLIPPING);
    else
        glEnable(GL_KOS_NEARZ_CLIPPING);


    glTranslatef(Position.x,Position.y,Position.z);

    glRotatef(-90, 0.0f, 1.0f, 0.0f);


    Apply();

    /* Expect CW verts */
    glFrontFace(GL_CW);

    glEnable(GL_TEXTURE_2D);


    draw_gl_md2(model,tex_id,
                Position.x,Position.y,Position.z,Delta_y,
                GetCurrentAnim(),GetNextAnim(),
                GetFrameCount(),GetFPS());



}


struct md2_model_node *ENTITY_MD2::GetModel(){return model;}



