/*********************************************************
**  File name : Context.hpp
**	Iris Engine V0.7 "presque"
**  Date Of Creation: 18/06/2002
**  Author : Olivier Chatry - Epitech Console Laboratory
**           (http://www.epitech.net/labconsole/)
*********************************************************/

#ifndef __CONTEXT_HPP__
#define __CONTEXT_HPP__

#include "CFrustrum.h"

const int FPS= 60;

class Context
{
protected:

    // 	pvr_poly_cxt_t		_cxt;
    // 	pvr_poly_hdr_t		_hdr;

    // 	bool				_light_enable;
    // 	bool				_cull_enable;
    // 	bool				_fill_mode;
    // 	bool				_world_tm_enable;
    // 	bool				_view_tm_enable;
    // 	bool				_projection_tm_enable;
    // 	bool				_texture_enable;
    // 	bool				_alpha_enable;
    // 	bool				_zbuffer_enable;
    // 	GeometryPipeline		_geom_pipeline;
    // 	LightingPipeline		_light_pipeline;
    // 	IrisMaterial				*_material;
    // 	InputManager				_input_manager;
    // 	IrisMaterialManager	_material_manager;
    // 	IrisObjectManager		_object_manager;
    CFrustum::CFrustum f;

public:
    static Context &Get()
    {
        static	Context	the_context;
        return	the_context;
    }

    CFrustum::CFrustum *GetFrustrum()
    {

        return	&f;
    }



    void				BeginScene()
    {

        //_input_manager.Update();
        glDepthMask(1);
        glDisable(GL_BLEND);
        glKosBeginFrame();
    }
    void				EndScene()
    {
        glKosFinishFrame();
    }
    void				BeginBlending()
    {
        glKosFinishList();
        glDepthMask(0);
        glEnable(GL_BLEND);
        glTexEnvi(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATEALPHA);
    }
    /*
     *	to do ...
     */
    void				BeginPunch()
    {
        glKosFinishList();
        glEnable(GL_BLEND);
        glTexEnvi(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATEALPHA);
    }

private:
    Context(){}
};
#endif //__CONTEXT_HPP__
