// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license
// v 0 (21.10.02): initial release

#ifndef GL_WRAP_H
#define GL_WRAP_H

#include "GL/gl.h"
#include "GL/glu.h"

//GL wrapper START

static void
glwSetView(GLfloat *angles,GLfloat *pos)
{
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glRotatef(90.0,0,0,1);
    glRotatef(90.0,0,1,0);

    glRotatef(angles[1],0,1,0);			/* Pitch*/
    glRotatef(angles[0],1,0,0);			/* Roll */
    glRotatef(angles[2],0,0,1);			/* Yaw  */
    glTranslatef(-pos[0],-pos[1],-pos[2]);
}
static void
glwLookAt(GLfloat *view_pos,GLfloat *at,GLfloat *up)
{
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(view_pos[0],view_pos[1],view_pos[2],
              at[0],at[1],at[2],up[0],up[1],up[2]);
}

static void
glwPerspectiveView(GLfloat fov,GLfloat aspect_ratio,
                   GLfloat near_clip,GLfloat far_clip)
{

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(fov,aspect_ratio,near_clip,far_clip);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

////GL Wrapper END
#endif
