/* Frustrum Culling Demo

   (Demonstrates checking if shapes are in view)

  original author : DigiBen	     digiben@gametutorials.com



*/

#ifndef _MAINA_H
#define _MAINA_H

// Return values of the various location functions
#define FULL_OUTSIDE 0
#define PARTIAL_INSIDE 1
#define FULL_INSIDE 2
#define ZMIN_INTERSECT 3

// This will allow us to create an object to keep track of our frustum
class CFrustum {

public:

    // Call this every time the camera moves to update the frustum
    void CalculateFrustum();

    // This takes a 3D point and returns TRUE if it's inside of the frustum
    bool PointInFrustum(float x, float y, float z);

    // This takes a 3D point and a radius and returns TRUE if the sphere is inside of the frustum
    int SphereInFrustum(float x, float y, float z, float radius);

    // This takes the center and half the length of the cube.
    bool CubeInFrustum( float x, float y, float z, float size );

    int CubeLocation(float fPoint[], float fSize);
    int SphereLocation(float *fPoint, float fRadius);

private:

    // This holds the A B C and D values for each side of our frustum.
    float m_Frustum[6][4];
};



#endif

