// AABB - axis aligned bounding box class
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license
// v 0 (01.11.02): initial release


#include "aabb.hpp"




/*********************************
* Creating from other primitives *
*********************************/
void AABB::MakeFromRay(const Vec3 *org,const Vec3 *dir,float len)
// Create an AABB from a ray with a specific length.
// This is useful for example if you want to raytrace into an AABBTree
// with a ray of limited length (like wheel vs. track intersections
// in Racer). The resulting AABB can be fed to the AABBTree and the potentially
// intersection boxes will be returned.
{
//qdbg("AABB:MakeFromRay(); len=%f\n",len);
//org->DbgPrint("org");
//dir->DbgPrint("dir");
  // Find out maximum extents of the ray
  if(dir->x<0){ min.x=org->x+dir->x*len; max.x=org->x; }
  else        { min.x=org->x; max.x=org->x+dir->x*len; }
  if(dir->y<0){ min.y=org->y+dir->y*len; max.y=org->y; }
  else        { min.y=org->y; max.y=org->y+dir->y*len; }
  if(dir->z<0){ min.z=org->z+dir->z*len; max.z=org->z; }
  else        { min.z=org->z; max.z=org->z+dir->z*len; }
}

