// QUAT Class
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// based on code by  by Alan Baylis 2001 and DigiBen
// under GPL or new BSD license
// v 0 (21.10.02): initial release
#ifndef QuatH
#define QuatH

#include "Vec3.h"
#include <GL/gl.h>

class QUAT
{
public:
    QUAT(GLfloat sx = 0, GLfloat sy = 0, GLfloat sz = 0, GLfloat sw = 1);
    ~QUAT();


    GLvoid Reset();
    GLvoid CopyQuat(QUAT q);
    GLvoid inline Set(GLfloat sx, GLfloat sy, GLfloat sz, GLfloat sw) {x = sx, y = sy, z = sz, w = sw;}
    GLvoid AxisAngleToQuat(Vec3 axis, GLfloat theta);
    GLvoid EulerToQuat(GLfloat pitch, GLfloat yaw, GLfloat roll);
    GLvoid NormaliseQuat();
    GLfloat MagnitudeQuat();
    GLvoid MultQuat(QUAT q);
    // This converts and axis angle rotation to a quaternion
    GLvoid CreateFromAxisAngle(GLfloat X, GLfloat Y, GLfloat Z, GLfloat degree);
    // This takes in an array of 16 floats to fill in a 4x4 homogeneous matrix from a quaternion
    GLvoid CreateMatrix(GLfloat *pMatrix);

    GLfloat x;
    GLfloat y;
    GLfloat z;
    GLfloat w;
};


#endif

